<!doctype html>
<html lang="en">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>What's new in BPF world?</title>

		<link rel="stylesheet" href="dist/reset.css">
		<link rel="stylesheet" href="dist/reveal.css">
		<link rel="stylesheet" href="dist/theme/white.css">

		<!-- Theme used for syntax highlighted code -->
		<link rel="stylesheet" href="plugin/highlight/monokai.css">

<style>
:root {
  --r-heading-color: #ee0000;
  --r-link-color: #ee0000;
  --r-selection-color: #ee0000;
  --r-main-font: "Red Hat Text";
  --r-heading-font: "Red Hat Display";
  --r-code-font: "Red Hat Mono";
}
.reveal h1,
.reveal h2,
.reveal h3,
.reveal h4 {
    text-transform: none;
}
code {
  font-size: .9em;
}
hl-text {
  font-weight: bold;
}
</style>
	</head>
	<body>
		<div class="reveal">
			<div class="slides">
                                <section>
                                        <h2>What's new in BPF world</h2>
                                        <h4>DevConf.CZ 2023</h4>
                                        <p>Viktor Malík &ltvmalik@redhat.com&gt</p>
                                        <p>Artem Savkov &ltasavkov@redhat.com&gt</p>
                                        <img src="Logo-Red_Hat-A-Standard-RGB.png" width=350px></img>
                                </section>
                                <section>
                                        <h2>Commit statistics</h2>
                                        <h4>2021.01-2023.03</h4>
                                        <img src="commit_graph_2021.01-2023.03.png">
                                </section>
                                <section>
                                        <h2>Quick recap - what is (e)BPF?</h2>
                                        <h4>(extended) Berkley Packet Filter</h4>
                                        <ul>
                                            <li>in-kernel VM for <hl-text>running sanboxed programs</hl-text></li>
                                            <li>programs are written using BPF instructions</li>
                                            <li>safety is assured by <hl-text>BPF verifier</hl-text></li>
                                            <li>programs can be <hl-text>attached to various events</hl-text> (kprobes, sockets, cgroups, etc.)</li>
                                        </ul>
                                </section>
                                <section>
                                        <h2>New features for writing BPF programs</h2>
                                </section>
                                <section>
                                        <h2>BPF kernel functions (kfuncs)</h2>
                                        <ul>
                                            <li>a new way to <hl-text>call existing kernel functions</hl-text></li>
                                            <li>very easy to create</li>
                                            <ul>
                                                <li>annotate the function with <code>__bpf_kfunc</code></li>
                                                <li>register the function for the correct program type</li>
                                            </ul>
                                            <br>
                                            <div class="fragment fade-in">
                                            <li>verifier does <hl-text>additional checks</hl-text> to ensure safety</li>
                                            <li>kfuncs can be annotated to help verifier do the job</li>
                                            </div>
                                        </ul>
                                </section>
                                <section>
                                        <h2>kfuncs example</h2>
                                        <h4>Registering kfuncs</h4>
                                        <pre><code data-trim data-noescape class="c" data-line-numbers="3|7-10">
                                        BTF_SET8_START(tracing_btf_ids)
                                        #ifdef CONFIG_KEXEC_CORE
                                        BTF_ID_FLAGS(func, crash_kexec, KF_DESTRUCTIVE)
                                        #endif
                                        BTF_SET8_END(tracing_btf_ids)

                                        static const struct btf_kfunc_id_set tracing_kfunc_set = {
                                                .owner = THIS_MODULE,
                                                .set   = &tracing_btf_ids,
                                        };
                                        </code></pre>
                                </section>
                                <section>
                                        <h2>kfuncs example</h2>
                                        <h4>Calling kfuncs</h4>
                                        <pre><code data-trim data-noescape class="c" data-line-numbers="1|3-8">
                                        extern void crash_kexec(struct pt_regs *) __ksym;

                                        SEC("fentry/bpf_fentry_test1")
                                        int BPF_PROG(bpf_fentry_test1)
                                        {
                                                crash_kexec();
                                                return 0;
                                        }
                                        </code></pre>
                                </section>
                                <section>
                                        <h2>Referenced pointers</h2>
                                        <ul>
                                            <li>facilitated by <hl-text>kfunc annotations</hl-text>:</li>
                                            <ul>
                                                <li><code>KF_ACQUIRE</code> &mdash; kfunc returns a referenced pointer</li>
                                                <li><code>KF_RELEASE</code> &mdash; kfunc releases a referenced pointer</li>
                                                <li>every acquired pointer must be released<br>(checked by verifier)</li>
                                            </ul>
                                            <br>
                                            <li class="fragment fade-in">can we release from a <hl-text>different BPF program</hl-text>?</li>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Long-lived kernel pointers</h2>
                                        <ul>
                                            <li>new kind of <hl-text>BPF pointers</hl-text> with special features:</li>
                                            <ul>
                                                <li>strongly-typed</li>
                                                <li>returned by helpers or kfuncs</li>
                                                <li>may be stored inside maps</li>
                                            </ul>
                                            <br>
                                            <div class="fragment fade-in">
                                            <li><hl-text>unreferenced</hl-text> &mdash; can be only read with <code>proberead</code>
                                            <li><hl-text>referenced</hl-text></li>
                                            <ul>
                                                <li>can be safely dereferenced (without <code>proberead</code>)</li>
                                                <li>can be passed to helpers and kfuncs</li>
                                                <li>automatically destroyed once the map is freed</li>
                                            </ul>
                                            </div>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Iteration in BPF programs</h2>
                                        <h4>Historical evolution</h4>
                                        <ul>
                                            <li>no loops allowed &mdash; too constraining</li>
                                            <li class="fragment fade-in">unrolled loops &mdash; impractical</li>
                                            <li class="fragment fade-in">fixed-iteration loops &mdash; difficult to verify</li>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Iteration in BPF programs</h2>
                                        <h4><code>bpf_loop</code> helper</h4>
                                        <pre><code data-trim data-noescape class="c" data-line-numbers>
                                        long bpf_loop(u32 iterations, long (*loop_fn)(u32 index, void *ctx),
                                                      void *ctx, u64 flags);
                                        </code></pre>
                                        <ul>
                                            <li>will result in <code>iterations</code> call to <code>loop_fn</code></li>
                                            <li>always terminates if <code>loop_fn</code> terminates</li>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Iteration in BPF programs</h2>
                                        <h4>BPF iterators</h4>
                                        <ul>
                                            <li><hl-text>special probes</hl-text> that are executed for each kernel object of a certain type</li>
                                            <li>supported types: tasks, files, VMAs, cgroups, ...</li>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Iteration in BPF programs</h2>
                                        <h4>Generic iterators</h4>
                                        <ul>
                                            <li>simple way to <hl-text>add new iterable objects</hl-text></li>
                                            <li>iterator over <hl-text>foo</hl-text> is implemented with:</li>
                                            <ul>
                                                <li><code>struct bpf_iter_foo</code> holding the iterator state</li>
                                                <li><code>bpf_iter_foo_new</code> kfunc to initialize iterator</li>
                                                <li><code>bpf_iter_foo_next</code> kfunc to get next element</li>
                                                <li><code>bpf_iter_foo_destroy</code> kfunc to destroy iterator</li>
                                            </ul>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Multi-link attachment</h2>
                                        <h4>Attaching one BPF program to many probes</h4>
                                        <ul>
                                            <li>new link type <hl-text><code>BPF_TRACE_KPROBE_MULTI</code><hl-text></li>
                                            <li>implemented using <hl-text>fprobes</hl-text></li>
                                            <ul>
                                                <li>concept similar to kprobes</li>
                                                <li>built on top of ftrace</li>
                                                <li>function entry/exit only (no arbitrary instructions)</li>
                                            </ul>
                                        </ul>
                                </section>
                                <section>
                                        <h2>Multi-link attachment</h2>
                                        <h4>Speed evaluation</h4>
                                        <pre><code data-trim data-noescape class="plaintext" data-line-numbers="1-4|6-10">
                                        perf stat --null -r 5 ./src/bpftrace -e 'kprobe:__x64_sys_* { } i:ms:1 { exit(); } '
                                        Attaching 426 probes...
                                        [...]
                                            15.13 +- 1.68 seconds time elapsed  ( +- 11.09% )

                                        perf stat --null -r 5 ./src/bpftrace -e 'kprobe:__x64_sys_* { } i:ms:1 { exit(); } '
                                        Attaching 2 probes...
                                        Attaching to 425 functions
                                        [...]
                                            0.8473 +- 0.0223 seconds time elapsed  ( +-  2.63% )
                                        </code></pre>
                                </section>
                                <section>
                                        <h2>BPF and memory management</h2>
                                        <ul>
                                                <li>bpf-specific memory allocator</li>
                                                <ul>
                                                        <li>allocated objects and linked lists</li>
                                                </ul>
                                                <li><code>bpf_prog_pack</code> allocator</li>
                                        </ul>
                                </section>
				<section>
                                        <h2>BPF-specific memory allocator</h2>
                                        <ul>
                                                <li>dynamic allocation of memory for bpf programs</li>
                                                <li>aimed to solve issues with allocations in stricter contexts</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>Dealing with interrupt contexts</h3>
                                        <ul>
                                                <li>pre-cache and maintain some memory in non-restrictive context</li>
                                                <li>use pre-cached memory in restrictive contexts</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>BPF allocator specifics</h3>
                                        <ul>
                                                <li>per-cpu caches</li>
                                                <ul>
                                                        <li>predefined size</li>
                                                        <li>variable size (uses 11 caches of set size underneath)</li>
                                                </ul>
                                                <li>managed in <code>irq_work</code></li>
                                                <li>high/low watermarks to keep wasted memory low</li>
                                        </ul>
                                </section>
                                <section>
                                        <h3>Interface</h3>
                                        <pre><code data-trim data-noescape class="c" data-line-numbers="1-3|5-7">
                                                /* kmalloc/kfree equivalent: */
                                                void *bpf_mem_alloc(struct bpf_mem_alloc *ma, size_t size);
                                                void bpf_mem_free(struct bpf_mem_alloc *ma, void *ptr);

                                                /* kmem_cache_alloc/free equivalent: */
                                                void *bpf_mem_cache_alloc(struct bpf_mem_alloc *ma);
                                                void bpf_mem_cache_free(struct bpf_mem_alloc *ma, void *ptr);
                                        </code></pre>
                                </section>
                                <section>
                                        <h3>Allocator initialization</h3>
                                        <pre><code data-trim data-noescape class="c" data-line-numbers>
                                                /* 'size != 0' is for bpf_mem_alloc which manages fixed-size objects.
                                                 * Alloc and free are done with bpf_mem_cache_{alloc,free}().
                                                 *
                                                 * 'size = 0' is for bpf_mem_alloc which manages many fixed-size objects.
                                                 * Alloc and free are done with bpf_mem_{alloc,free}() and the size of
                                                 * the returned object is given by the size argument of bpf_mem_alloc().
                                                 */
                                                int bpf_mem_alloc_init(struct bpf_mem_alloc *ma, int size, bool percpu);
                                                void bpf_mem_alloc_destroy(struct bpf_mem_alloc *ma);
                                        </code></pre>
                                </section>
				<section>
                                        <h3>Real life applications</h3>
                                        <ul>
                                                <li>hash map implementation</li>
                                                <li><code>bpf_local_storage</code></li>
                                                <li>allocated objects, linked lists</li>
                                        </ul>
                                </section>
				<section>
                                        <h2>Allocated objects and linked lists</h2>
                                        <ul>
                                                <li>allows creating flexible data structures</li>
                                                <li>linked lists holding allocated objects as elements</li>
                                                <li>verificator checked</li>
                                                <li>experimental</li>
                                                <li class="fragment"><code>.../selftests/bpf</code><code class="fragment">/bpf_experimental.h</code></li>
                                        </ul>
                                </section>
				<section>
                                        <h3>bpf_prog_pack allocator</h3>
                                        <ul>
                                                <li>saves memory</li>
                                                <li><s>improves performance</s></li>
                                                <li>inspired generic execmem allocator attempt</li>
                                                <li>covered by lwn</li>
                                                <ul>
                                                        <li><a href="https://lwn.net/Articles/883454">https://lwn.net/Articles/883454</a></li>
                                                        <li><a href="https://lwn.net/Articles/892743">https://lwn.net/Articles/892743</a></li>
                                                        <li><a href="https://lwn.net/Articles/915005">https://lwn.net/Articles/915005</a></li>
                                                </ul>
                                        </ul>
                                </section>
				<section>
                                        <h2>BPF program signing</h2>
                                        <ul>
                                                <li>bpf programs != kernel modules</li>
                                                <li>libbpf does the bulk of work during loading</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>Approaching the problem</h3>
                                        <ul>
                                                <li>move libbpf into the kernel</li>
                                                <li>new file format</li>
                                                <li>new bpf program type</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>libbpf program loading phases</h3>
                                        <ul>
                                                <li>open phase</li>
                                                <li>load phase</li>
                                                <li>attachment phase</li>
                                                <li>teardown phase</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>libbpf open phase</h3>
                                        <ul>
                                                <li>parses object file</li>
                                                <li>discovers maps, programs, global vars</li>
                                                <li>notes down relocations</li>
                                                <li>collects external functions and ksyms including their btf_ids</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>libbpf load phase</h3>
                                        <ul>
                                                <li>probes kernel features</li>
                                                <li>loads btfs</li>
                                                <li>resolves ksyms, externs</li>
                                                <li>creates maps</li>
                                                <li>applies relocations, patches code</li>
                                                <li>verifies program</li>
                                                <li>no code execution until attachment phase</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>Map FDs</h3>
                                        <ul>
                                                <li>maps are accessed through fds determined on load</li>
                                                <li>solved by a new level of abstraction - fd arrays</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>Loader programs</h3>
                                        <ul>
                                                <li>record <code>sys_bpf()</code> calls</li>
                                                <li>play them back through new bpf prog type</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>lskel: light/loader skeleton</h3>
                                        <ul>
                                                <li><code>*.bpf.c -> *.bpf.o -> *.skel.h -> *.c</code></li>
                                                <li>does not include original elf</li>
                                                <li>does not include libbpf headers</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>In-kernel CO-RE support</h3>
                                        <ul>
                                                <li>full <code>relo_core.c</code> in kernel</li>
                                                <li>allows to remove libbpf dependency from <code>bpf_preload_umd</code></li>
                                                <li>enables languages that can't adopt libbpf to take advantage of CO-RE</li>
                                        </ul>
                                </section>
				<section>
                                        <h3>Light skeleton in the kernel</h3>
                                        <ul>
                                                <li>allows to drop user-mode-driver from <code>bpf_preload</code></li>
                                                <li>allows to sign bpf code <hl-text class="fragment">(kind of)</hl-text></li>
                                        </ul>
                                </section>
				<section>
                                        <h1>Q&A</h1>
                                </section>
				<section>
                                        <h1>Thank you</h1>
                                </section>
			</div>
		</div>

		<script src="dist/reveal.js"></script>
		<script src="plugin/notes/notes.js"></script>
		<script src="plugin/markdown/markdown.js"></script>
		<script src="plugin/highlight/highlight.js"></script>
		<script>
			// More info about initialization & config:
			// - https://revealjs.com/initialization/
			// - https://revealjs.com/config/
			Reveal.initialize({
				hash: true,
                width: 1024,

				// Learn about plugins: https://revealjs.com/plugins/
				plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
			});
		</script>
	</body>
</html>
